local idTweaks = LibStub('AceAddon-3.0'):NewAddon('idTweaks', 'AceConsole-3.0')

function idTweaks:setDefaults()
  self.defaults = {
    profile = {
    }
  }
end

function idTweaks:setDatabase()
  self.db = LibStub('AceDB-3.0'):New('idTweaksDB', self.defaults, 'Default')
end

function idTweaks:setOptions()
  self.options = {
    name = 'idTweaks',
    handler = self,
    type = 'group',
    args = {
    }
  }

  self.profileOptions = LibStub('AceDBOptions-3.0'):GetOptionsTable(self.db)
end

function idTweaks:registerOptions()
  LibStub('AceConfig-3.0'):RegisterOptionsTable('idTweaks', self.options, { 'idt', 'idtweaks' })
  LibStub('AceConfigDialog-3.0'):AddToBlizOptions('idTweaks')

  LibStub('AceConfig-3.0'):RegisterOptionsTable('idTweaks-Profiles', self.profileOptions)
  LibStub('AceConfigDialog-3.0'):AddToBlizOptions('idTweaks-Profiles', 'Profiles', 'idTweaks')
end

function idTweaks:OnInitialize()
  self:setDefaults()
  self:setDatabase()
  self:setOptions()
  self:registerOptions()
end

function idTweaks:OnEnable()
end

function idTweaks:OnDisable()
end

idTweaks.table = {
  reverse = function(t)
    local out = {}
    for k, v in pairs(t) do
      out[v] = k
    end
    return out
  end,

  copy = function(a, b)
    for k, v in pairs(b) do
      a[k] = v
    end
  end,

  merge = function(...)
    local out = {}
    for i, t in ipairs({...}) do
      idTweaks.table.copy(out, t)
    end
    return out
  end,
}
